/// @cond EO_CXX_EO_IMPL

inline ::eldbus::model_proxy::_c_constructor eldbus::model_proxy::constructor(Eldbus_Object * object_, const Eldbus_Introspection_Interface * interface_)
{
   return _c_constructor(object_, interface_);
}

inline ::efl::eina::string_view eldbus::model_proxy::name_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::eldbus_model_proxy_name_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::efl::eina::string_view eo_cxx::eldbus::model_proxy::name_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::eldbus_model_proxy_name_get());
   return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::eo_cxx::eldbus::model_proxy::operator ::eldbus::model_proxy() const
{
   return *static_cast<::eldbus::model_proxy const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::eldbus::model_proxy::operator ::eldbus::model_proxy&()
{
   return *static_cast<::eldbus::model_proxy*>(static_cast<void*>(this));
}

inline ::eo_cxx::eldbus::model_proxy::operator ::eldbus::model_proxy const&() const
{
   return *static_cast<::eldbus::model_proxy const*>(static_cast<void const*>(this));
}

template <typename T>
::efl::eina::string_view eldbus_model_proxy_name_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->name_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::eldbus::model_proxy >
{
   template <typename T>
   struct type
         : virtual operations< ::eo::base >::template type<T>
         , virtual operations< ::efl::model::base >::template type<T>
   {
      virtual ::efl::eina::string_view name_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::eldbus_model_proxy_name_get());
            return ::efl::eolian::to_cxx<::efl::eina::string_view>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::eldbus::model_proxy >
{
   static constexpr int value = 
#if defined(MODEL_PROXY_PROTECTED) && defined(MODEL_PROXY_BETA)
      1
#elif defined(MODEL_PROXY_PROTECTED)
      1
#elif defined(MODEL_PROXY_BETA)
      1
#else
      1
#endif
      + operation_description_class_size<::eo::base >::value      + operation_description_class_size<::efl::model::base >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::eldbus::model_proxy>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::eldbus_model_proxy_name_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::eldbus_model_proxy_name_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::eo::base>(), &ops[operation_description_class_size< ::eldbus::model_proxy >::value]);
   initialize_operation_description<T>(::efl::eo::detail::tag<::efl::model::base>(), &ops[operation_description_class_size< ::eldbus::model_proxy >::value + operation_description_class_size<::eo::base>::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::eldbus::model_proxy>)
{
   return (ELDBUS_MODEL_PROXY_CLASS);
}

} } }

/// @endcond

